package logwire.web.bo.eventhandler;

import logwire.web.bo.object.BizObject;

import java.util.List;

public interface ListOperationEventHandler<X extends BizObject> {
    String getOperation();

    boolean isEnabled();

    default String getQuery() {
        return "";
    }

    default boolean isAfter() {
        return true;
    }

    default int getOrder() {
        return 1000;
    }

    default void doBefore(List<X> xList, Object... args) {
        //调用行为同名方法
    }

    default void doAfter(List<X> xList, Object result, Object... args) {
        //调用行为同名方法
    }
}