package logwire.web.bo.handler;

import logwire.web.bo.object.BizObject;

import java.util.List;

public interface ListOperationHandler<X extends BizObject> {
    String getOperation();

    boolean isEnabled();

    default String getQuery() {
        return "";
    }

    default int getOrder() {
        return 1000;
    }

    default boolean accept(List<X> xList, Object... args) {
        return true;
    }

    Object execute(List<X> xList, Object... args);
}
